#version 330

in vec2 TexCoord0;

out vec2 FragColor; // x .. contains luminance, y .. contains log luminance

uniform sampler2D Texture0;

void main()
{
	const vec3 lum = vec3(0.2126, 0.7152, 0.0722);
	//const vec3 lum = vec3(0.299, 0.587, 0.114);
	//const vec3 lum = vec3(0.27, 0.67, 0.06);

	// concentrate on the central part of the image only:
	const float border = 0.2f;
	vec2 texCoords = min(vec2(1.0f - border), max(vec2(border), TexCoord0));

	vec3 rgb = texture(Texture0, texCoords).rgb;
	float extractedLum = dot(lum, rgb);
	
	const float delta = 0.0001;
	FragColor = vec2(max(delta, extractedLum), log(delta + extractedLum));
}
