#version 330

in vec2 TexCoord0;

out vec2 FragColor;

uniform sampler2D Texture0;
uniform int SampleLevel;

void main()
{
	
	ivec2 tc = ivec2((gl_FragCoord.xy - 0.5) * 2.0); // texel coordinates

	vec2 tx1 = texelFetch(Texture0, tc, SampleLevel).rg;
	vec2 tx2 = texelFetch(Texture0, tc+ivec2(1,0), SampleLevel).rg;
	vec2 tx3 = texelFetch(Texture0, tc+ivec2(0,1), SampleLevel).rg;
	vec2 tx4 = texelFetch(Texture0, tc+ivec2(1,1), SampleLevel).rg;

	float maxV = max( max(tx1.x, tx2.x), max(tx3.x, tx4.x) );
	float avgV = (tx1.y + tx2.y + tx3.y + tx4.y) / 4.0f;

	FragColor = vec2(maxV, avgV);
}
